"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ValidationUtils = void 0;
const vector_utils_1 = require("@connext/vector-utils");
const ethers_1 = require("ethers");
const inversify_1 = require("inversify");
let ValidationUtils = class ValidationUtils {
    validatePublicIdentifier(publicIdentifier) {
        return (0, vector_utils_1.isValidPublicIdentifier)(publicIdentifier);
    }
    validateEthereumAddress(ethereumAddress) {
        return ethers_1.utils.isAddress(ethereumAddress);
    }
    validateWeiAmount(amount) {
        try {
            ethers_1.utils.parseUnits(amount, "wei");
            return true;
        }
        catch {
            return false;
        }
    }
    validatePaymentId(paymentId) {
        const overallRegex = /^0x[0-9A-Fa-f]{64}$/;
        return overallRegex.test(paymentId);
    }
};
ValidationUtils = __decorate([
    (0, inversify_1.injectable)()
], ValidationUtils);
exports.ValidationUtils = ValidationUtils;
//# sourceMappingURL=ValidationUtils.js.map